c8e260479953f66f844e6de9df7ce29df61714d1
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 _exit_handler() {
16   local rc="$?"
17   trap - EXIT
18   if [ "$rc" -ne 0 ]; then
19     echo "Error occurred ($rc) while running $0 at line $1 : $BASH_COMMAND"
20   fi
21   exit "$rc"
22 }
23
24 trap '_exit_handler $LINENO' EXIT ERR
25
26 # capture the directory that the script is running from
27 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
28
29 usage() {
30   echo >&2
31   echo >&2 "Usage: ${0} [-h] [-h]"
32   echo >&2
33   echo >&2 "${0} options:"
34   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
35   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
36   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
37   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
38   echo >&2 "                                              Possible values are:"
39   echo >&2 "                                                api"
40   echo >&2 "                                                controller"
41   echo >&2 "                                                dispatcher"
42   echo >&2 "                                                keepproxy"
43   echo >&2 "                                                keepbalance"
44   echo >&2 "                                                keepstore"
45   echo >&2 "                                                keepweb"
46   echo >&2 "                                                shell"
47   echo >&2 "                                                webshell"
48   echo >&2 "                                                websocket"
49   echo >&2 "                                                workbench"
50   echo >&2 "                                                workbench2"
51   echo >&2 "                                              Defaults to applying them all"
52   echo >&2 "  -h, --help                                  Display this help and exit"
53   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
54   echo >&2 "                                              This parameter does not perform any installation at all. It's"
55   echo >&2 "                                              intended to give you a parsed sot of configuration files so"
56   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
57   echo >&2 "                                              It"
58   echo >&2 "                                                - parses the pillar and states templates,"
59   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
60   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
61   echo >&2 "                                                  for the selected role/s"
62   echo >&2 "                                                - writes the resulting files into <dest_dir>"
63   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
64   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
65   echo >&2
66 }
67
68 arguments() {
69   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
70   if ! which getopt > /dev/null; then
71     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
72     exit 1
73   fi
74
75   TEMP=$(getopt -o c:dhp:r:tv \
76     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
77     -n "${0}" -- "${@}")
78
79   if [ ${?} != 0 ];
80     then echo "Please check the parameters you entered and re-run again"
81     exit 1
82   fi
83   # Note the quotes around `$TEMP': they are essential!
84   eval set -- "$TEMP"
85
86   while [ ${#} -ge 1 ]; do
87     case ${1} in
88       -c | --config)
89         CONFIG_FILE=${2}
90         shift 2
91         ;;
92       -d | --debug)
93         LOG_LEVEL="debug"
94         shift
95         set -x
96         ;;
97       --dump-config)
98         if [[ ${2} = /* ]]; then
99           DUMP_SALT_CONFIG_DIR=${2}
100         else
101           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
102         fi
103         ## states
104         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
105         ## formulas
106         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
107         ## pillars
108         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
109         ## tests
110         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
111         DUMP_CONFIG="yes"
112         shift 2
113         ;;
114       --development)
115         DEV_MODE="yes"
116         shift 1
117         ;;
118       -r | --roles)
119         for i in ${2//,/ }
120           do
121             # Verify the role exists
122             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
123               echo "The role '${i}' is not a valid role"
124               usage
125               exit 1
126             fi
127             ROLES="${ROLES} ${i}"
128           done
129           shift 2
130         ;;
131       -t | --test)
132         TEST="yes"
133         shift
134         ;;
135       -v | --vagrant)
136         VAGRANT="yes"
137         shift
138         ;;
139       --)
140         shift
141         break
142         ;;
143       *)
144         usage
145         exit 1
146         ;;
147     esac
148   done
149 }
150
151 copy_custom_cert() {
152   cert_dir=${1}
153   cert_name=${2}
154
155   mkdir -p /srv/salt/certs
156
157   if [ -f ${cert_dir}/${cert_name}.crt ]; then
158     cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
159   else
160     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
161     exit 1
162   fi
163   if [ -f ${cert_dir}/${cert_name}.key ]; then
164     cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
165   else
166     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
167     exit 1
168   fi
169 }
170
171 DEV_MODE="no"
172 CONFIG_FILE="${SCRIPT_DIR}/local.params"
173 CONFIG_DIR="local_config_dir"
174 DUMP_CONFIG="no"
175 LOG_LEVEL="info"
176 CONTROLLER_EXT_SSL_PORT=443
177 TESTS_DIR="tests"
178
179 NGINX_INSTALL_SOURCE="install_from_repo"
180
181 CLUSTER=""
182 DOMAIN=""
183
184 # Hostnames/IPs used for single-host deploys
185 IP_INT="127.0.1.1"
186
187 # Initial user setup
188 INITIAL_USER=""
189 INITIAL_USER_EMAIL=""
190 INITIAL_USER_PASSWORD=""
191
192 CONTROLLER_EXT_SSL_PORT=8000
193 KEEP_EXT_SSL_PORT=25101
194 # Both for collections and downloads
195 KEEPWEB_EXT_SSL_PORT=9002
196 WEBSHELL_EXT_SSL_PORT=4202
197 WEBSOCKET_EXT_SSL_PORT=8002
198 WORKBENCH1_EXT_SSL_PORT=443
199 WORKBENCH2_EXT_SSL_PORT=3001
200
201 SSL_MODE="self-signed"
202 USE_LETSENCRYPT_ROUTE53="no"
203 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
204
205 ## These are ARVADOS-related parameters
206 # For a stable release, change RELEASE "production" and VERSION to the
207 # package version (including the iteration, e.g. X.Y.Z-1) of the
208 # release.
209 # The "local.params.example.*" files already set "RELEASE=production"
210 # to deploy  production-ready packages
211 RELEASE="development"
212 VERSION="latest"
213
214 # These are arvados-formula-related parameters
215 # An arvados-formula tag. For a stable release, this should be a
216 # branch name (e.g. X.Y-dev) or tag for the release.
217 # ARVADOS_TAG="2.2.0"
218 # BRANCH="main"
219
220 # Other formula versions we depend on
221 POSTGRES_TAG="v0.44.0"
222 NGINX_TAG="v2.8.1"
223 DOCKER_TAG="v2.4.2"
224 LOCALE_TAG="v0.3.4"
225 LETSENCRYPT_TAG="v2.1.0"
226
227 # Salt's dir
228 DUMP_SALT_CONFIG_DIR=""
229 ## states
230 S_DIR="/srv/salt"
231 ## formulas
232 F_DIR="/srv/formulas"
233 ## pillars
234 P_DIR="/srv/pillars"
235 ## tests
236 T_DIR="/tmp/cluster_tests"
237
238 arguments ${@}
239
240 if [ -s ${CONFIG_FILE} ]; then
241   source ${CONFIG_FILE}
242 else
243   echo >&2 "You don't seem to have a config file with initial values."
244   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
245   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
246   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
247   exit 1
248 fi
249
250 if [ ! -d ${CONFIG_DIR} ]; then
251   echo >&2 "You don't seem to have a config directory with pillars and states."
252   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
253   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
254   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
255   exit 1
256 fi
257
258 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
259   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
260   echo >&2 "Please, fix them and re-run the provision script."
261   exit 1
262 fi
263
264 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
265   echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
266   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
267   exit 1
268 fi
269
270 # Only used in single_host/single_name deploys
271 if [ ! -z "${HOSTNAME_EXT}" ] ; then
272   # We need to add some extra control vars to manage a single certificate vs. multiple
273   USE_SINGLE_HOSTNAME="yes"
274   # Make sure that the value configured as IP_INT is a real IP on the system.
275   # If we don't error out early here when there is a mismatch, the formula will
276   # fail with hard to interpret nginx errors later on.
277   ip addr list |grep "${IP_INT}/" >/dev/null
278   if [[ $? -ne 0 ]]; then
279     echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
280     exit 1
281   fi
282 else
283   USE_SINGLE_HOSTNAME="no"
284   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
285   # conditionals
286   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
287 fi
288
289 if [ "${DUMP_CONFIG}" = "yes" ]; then
290   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
291 else
292   # Install a few dependency packages
293   # First, let's figure out the OS we're working on
294   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
295   echo "Detected distro: ${OS_ID}"
296
297   case ${OS_ID} in
298     "centos")
299       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
300       sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
301       setenforce permissive
302       yum install -y  curl git jq
303       ;;
304     "debian"|"ubuntu")
305       # Wait 2 minutes for any apt locks to clear
306       # This option is supported from apt 1.9.1 and ignored in older apt versions.
307       # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
308       DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
309       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
310       ;;
311   esac
312
313   if which salt-call; then
314     echo "Salt already installed"
315   else
316     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
317     sh /tmp/bootstrap_salt.sh -XdfP -x python3
318     /bin/systemctl stop salt-minion.service
319     /bin/systemctl disable salt-minion.service
320   fi
321
322   # Set salt to masterless mode
323   cat > /etc/salt/minion << EOFSM
324 failhard: "True"
325
326 file_client: local
327 file_roots:
328   base:
329     - ${S_DIR}
330     - ${F_DIR}/*
331
332 pillar_roots:
333   base:
334     - ${P_DIR}
335 EOFSM
336 fi
337
338 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
339
340 # Get the formula and dependencies
341 cd ${F_DIR} || exit 1
342 echo "Cloning formulas"
343 rm -rf ${F_DIR}/* || exit 1
344 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
345 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
346
347 echo "...locale"
348 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
349 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
350
351 echo "...nginx"
352 git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
353 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
354
355 echo "...postgres"
356 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
357 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
358
359 echo "...letsencrypt"
360 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
361 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
362
363 echo "...arvados"
364 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
365
366 # If we want to try a specific branch of the formula
367 if [ "x${BRANCH}" != "x" -a $(git rev-parse --abbrev-ref HEAD) != "${BRANCH}" ]; then
368   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
369 elif [ "x${ARVADOS_TAG}" != "x" -a $(git rev-parse --abbrev-ref HEAD) != "${ARVADOS_TAG}" ]; then
370 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
371 fi
372
373 if [ "x${VAGRANT}" = "xyes" ]; then
374   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
375   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
376   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
377 else
378   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
379   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
380   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
381 fi
382
383 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
384
385 echo "Writing pillars and states"
386
387 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
388 # to ease deployment for newcomers
389 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
390   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
391   exit 1
392 fi
393 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
394   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
395        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
396        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
397        s#__CLUSTER__#${CLUSTER}#g;
398        s#__DOMAIN__#${DOMAIN}#g;
399        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
400        s#__IP_INT__#${IP_INT}#g;
401        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
402        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
403        s#__INITIAL_USER__#${INITIAL_USER}#g;
404        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
405        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
406        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
407        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
408        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
409        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
410        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
411        s#__RELEASE__#${RELEASE}#g;
412        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
413        s#__VERSION__#${VERSION}#g;
414        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
415        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
416        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
417        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
418        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
419        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
420        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
421        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
422        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
423        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
424        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
425        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
426        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
427        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
428        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
429        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
430        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
431   "${f}" > "${P_DIR}"/$(basename "${f}")
432 done
433
434 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
435   echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
436   if [ "x${TEST}" = "xyes" ]; then
437     echo "WARNING: Disabling tests for this installation."
438   fi
439   TEST="no"
440 else
441   mkdir -p ${T_DIR}
442   # Replace cluster and domain name in the test files
443   for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
444     FILTERS="s#__CLUSTER__#${CLUSTER}#g;
445          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
446          s#__DOMAIN__#${DOMAIN}#g;
447          s#__IP_INT__#${IP_INT}#g;
448          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
449          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
450          s#__INITIAL_USER__#${INITIAL_USER}#g;
451          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
452          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
453     if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
454       FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
455          $FILTERS"
456     fi
457     sed "$FILTERS" \
458       "${f}" > ${T_DIR}/$(basename "${f}")
459   done
460   chmod 755 ${T_DIR}/run-test.sh
461 fi
462
463 # Replace helper state files that differ from the formula's examples
464 if [ -d "${SOURCE_STATES_DIR}" ]; then
465   mkdir -p "${F_DIR}"/extra/extra
466
467   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
468     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
469          s#__CLUSTER__#${CLUSTER}#g;
470          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
471          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
472          s#__DOMAIN__#${DOMAIN}#g;
473          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
474          s#__IP_INT__#${IP_INT}#g;
475          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
476          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
477          s#__INITIAL_USER__#${INITIAL_USER}#g;
478          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
479          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
480          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
481          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
482          s#__RELEASE__#${RELEASE}#g;
483          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
484          s#__VERSION__#${VERSION}#g;
485          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
486          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
487          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
488          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
489          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
490          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
491          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
492          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
493          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
494          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
495          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
496          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
497          s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
498          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
499          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
500          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
501          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
502     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
503   done
504 fi
505
506 # Now, we build the SALT states/pillars trees
507 # As we need to separate both states and pillars in case we want specific
508 # roles, we iterate on both at the same time
509
510 # States
511 cat > ${S_DIR}/top.sls << EOFTSLS
512 base:
513   '*':
514     - locale
515 EOFTSLS
516
517 # Pillars
518 cat > ${P_DIR}/top.sls << EOFPSLS
519 base:
520   '*':
521     - locale
522     - arvados
523 EOFPSLS
524
525 # States, extra states
526 if [ -d "${F_DIR}"/extra/extra ]; then
527   SKIP_SNAKE_OIL="snakeoil_certs"
528
529   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
530     # In dev mode, we create some snake oil certs that we'll
531     # use as CUSTOM_CERTS, so we don't skip the states file.
532     # Same when using self-signed certificates.
533     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
534   fi
535   for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
536   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
537   done
538   # Use byo or self-signed certificates
539   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
540     mkdir -p "${F_DIR}"/extra/extra/files
541   fi
542 fi
543
544 # If we want specific roles for a node, just add the desired states
545 # and its dependencies
546 if [ -z "${ROLES}" ]; then
547   # States
548   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
549   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
550     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
551       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
552     fi
553     grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
554   else
555     mkdir -p /srv/salt/certs
556     if [ "${SSL_MODE}" = "bring-your-own" ]; then
557       # Copy certs to formula extra/files
558       cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
559       # We add the custom_certs state
560       grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
561     fi
562     # In self-signed mode, the certificate files will be created and put in the
563     # destination directory by the snakeoil_certs.sls state file
564   fi
565
566   echo "    - postgres" >> ${S_DIR}/top.sls
567   echo "    - docker.software" >> ${S_DIR}/top.sls
568   echo "    - arvados" >> ${S_DIR}/top.sls
569   echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
570   echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
571   echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
572
573   # Pillars
574   echo "    - docker" >> ${P_DIR}/top.sls
575   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
576   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
577   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
578   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
579   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
580   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
581   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
582   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
583   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
584   echo "    - postgresql" >> ${P_DIR}/top.sls
585
586   # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
587   NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
588   sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
589
590   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
591     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
592       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
593     fi
594     grep -q "letsencrypt" ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
595
596     hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
597     if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
598       hosts+=("download" "collections")
599     else
600       hosts+=("keepweb")
601     fi
602
603     for c in "${hosts[@]}"; do
604       # Are we in a single-host-single-hostname env?
605       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
606         # Are we in a single-host-single-hostname env?
607         CERT_NAME=${HOSTNAME_EXT}
608       else
609         # We are in a multiple-hostnames env
610         CERT_NAME=${c}.${CLUSTER}.${DOMAIN}
611       fi
612
613       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
614       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
615               s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
616               s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
617       ${P_DIR}/nginx_${c}_configuration.sls
618     done
619   else
620     # Use custom certs (either dev mode or prod)
621     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
622     # And add the certs in the custom_certs pillar
623     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
624     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
625
626     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
627       # Are we in a single-host-single-hostname env?
628       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
629         # Are we in a single-host-single-hostname env?
630         CERT_NAME=${HOSTNAME_EXT}
631       else
632         # We are in a multiple-hostnames env
633         CERT_NAME=${c}
634       fi
635
636       if [[ "$SSL_MODE" == "bring-your-own" ]]; then
637         copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
638       fi
639
640       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
641
642       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
643       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
644               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
645               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
646       ${P_DIR}/nginx_${c}_configuration.sls
647     done
648   fi
649 else
650   # If we add individual roles, make sure we add the repo first
651   echo "    - arvados.repo" >> ${S_DIR}/top.sls
652   # We add the extra_custom_certs state
653   grep -q "extra.custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
654
655   # And we add the basic part for the certs pillar
656   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
657     # And add the certs in the custom_certs pillar
658     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
659     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
660     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
661   fi
662
663   for R in ${ROLES}; do
664     case "${R}" in
665       "database")
666         # States
667         echo "    - postgres" >> ${S_DIR}/top.sls
668         # Pillars
669         echo '    - postgresql' >> ${P_DIR}/top.sls
670       ;;
671       "api")
672         # States
673         # FIXME: https://dev.arvados.org/issues/17352
674         grep -q "postgres.client" ${S_DIR}/top.sls || echo "    - postgres.client" >> ${S_DIR}/top.sls
675         if grep -q "    - nginx.*$" ${S_DIR}/top.sls; then
676           sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
677         else
678           echo "    - nginx.passenger" >> ${S_DIR}/top.sls
679         fi
680         echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
681         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
682         ### after it. So we add this here as we are, after all, sharing the host for api and controller
683         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
684           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
685             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
686           fi
687           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
688         else
689           # Use custom certs
690           if [ "${SSL_MODE}" = "bring-your-own" ]; then
691             copy_custom_cert ${CUSTOM_CERTS_DIR} controller
692           fi
693           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
694         fi
695         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
696         # Pillars
697         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
698         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
699         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
700         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
701
702         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
703         NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
704         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
705       ;;
706       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
707         NGINX_INSTALL_SOURCE="install_from_repo"
708         # States
709         if [ "${R}" = "workbench" ]; then
710           NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
711           if grep -q "    - nginx$" ${S_DIR}/top.sls; then
712             sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
713           else
714             echo "    - nginx.passenger" >> ${S_DIR}/top.sls
715           fi
716         else
717           grep -q "nginx" ${S_DIR}/top.sls || echo "    - nginx" >> ${S_DIR}/top.sls
718         fi
719         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
720           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
721             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
722           fi
723           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
724         else
725           # Use custom certs, special case for keepweb
726           if [ ${R} = "keepweb" ]; then
727             if [ "${SSL_MODE}" = "bring-your-own" ]; then
728               copy_custom_cert ${CUSTOM_CERTS_DIR} download
729               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
730             fi
731           else
732             if [ "${SSL_MODE}" = "bring-your-own" ]; then
733               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
734             fi
735           fi
736         fi
737         # webshell role is just a nginx vhost, so it has no state
738         if [ "${R}" != "webshell" ]; then
739           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
740         fi
741         # Pillars
742         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
743         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
744         # Special case for keepweb
745         if [ ${R} = "keepweb" ]; then
746           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
747           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
748         fi
749
750         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
751           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
752             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
753           fi
754           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
755           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
756
757           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
758           # Special case for keepweb
759           if [ ${R} = "keepweb" ]; then
760             for kwsub in download collections; do
761               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
762                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
763                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
764               ${P_DIR}/nginx_${kwsub}_configuration.sls
765             done
766           else
767             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
768                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
769                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
770             ${P_DIR}/nginx_${R}_configuration.sls
771           fi
772         else
773           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
774           # Special case for keepweb
775           if [ ${R} = "keepweb" ]; then
776             for kwsub in download collections; do
777               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
778                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
779                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
780               ${P_DIR}/nginx_${kwsub}_configuration.sls
781               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
782             done
783           else
784             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
785                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
786                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
787             ${P_DIR}/nginx_${R}_configuration.sls
788             grep -q ${R}$ ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
789           fi
790         fi
791         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
792         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
793       ;;
794       "shell")
795         # States
796         echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
797         echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
798         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
799         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
800         # Pillars
801         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
802       ;;
803       "dispatcher" | "keepbalance" | "keepstore")
804         # States
805         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
806         # Pillars
807         # ATM, no specific pillar needed
808       ;;
809       *)
810         echo "Unknown role ${R}"
811         exit 1
812       ;;
813     esac
814   done
815 fi
816
817 if [ "${DUMP_CONFIG}" = "yes" ]; then
818   # We won't run the rest of the script because we're just dumping the config
819   exit 0
820 fi
821
822 # Now run the install
823 salt-call --local state.apply -l ${LOG_LEVEL}
824
825 # Finally, make sure that /etc/hosts is not overwritten on reboot
826 if [ -d /etc/cloud/cloud.cfg.d ]; then
827   # TODO: will this work on CentOS?
828   sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
829 fi
830
831 # Leave a copy of the Arvados CA so the user can copy it where it's required
832 if [ "$DEV_MODE" = "yes" ]; then
833   ARVADOS_SNAKEOIL_CA_DEST_FILE="${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem"
834
835   # If running in a vagrant VM, also add default user to docker group
836   if [ "x${VAGRANT}" = "xyes" ]; then
837     echo "Adding the vagrant user to the docker group"
838     usermod -a -G docker vagrant
839     ARVADOS_SNAKEOIL_CA_DEST_FILE="/vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem"
840   fi
841   if [ -f /etc/ssl/certs/arvados-snakeoil-ca.pem ]; then
842     echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
843     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${ARVADOS_SNAKEOIL_CA_DEST_FILE}
844   fi
845 fi
846
847 # Test that the installation finished correctly
848 if [ "x${TEST}" = "xyes" ]; then
849   cd ${T_DIR}
850   # If we use RVM, we need to run this with it, or most ruby commands will fail
851   RVM_EXEC=""
852   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
853     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
854   fi
855   ${RVM_EXEC} ./run-test.sh
856 fi